; File: C:\Data\Project\Sintendo\DC32Snes9x\Snes9x\cpu.cpp
    .export     `?S9xResetSuperFX@@YAXXZ`
    .export     `?S9xResetCPU@@YAXXZ`
    .export     _S9xReset
    .import     _S9xResetPPU
    .import     `?SuperFX@@3UFxInit_s@@A`
    .import     __imp__sprintf
    .import     _S9xSA1Init
    .import     _S9xResetDMA
    .import     __imp___wfopen
    .import     `?FxReset@@YAXPAUFxInit_s@@@Z`
    .import     _ICPU
    .import     _S9xOpcodesM1X1
    .import     _Memory
    .import     _S9xResetAPU
    .import     `?S9xGetWord@@YAGI@Z`
    .import     __imp__mbstowcs
    .import     _CPU
    .import     _Registers
    .import     _Settings
    .import     `?S9xInitCheatData@@YAXXZ`
    .import     __imp__fread
    .import     `?S9xSetPCBase@@YAXI@Z`
    .import     _S9xResetDSP1
    .import     _memset

    .section    .drectve, data, align=4
    .sdata      "-defaultlib:corelibc.lib -defaultlib:coredll.lib"
;   56: {
    .align      4

    .section    .text, code, align=4

`?S9xResetSuperFX@@YAXXZ`: .entry
    sts.l       pr,@-sp
    add.l       #-16,sp         ; -16 = 0xfffffff0
    .prolog
;   57:     SuperFX.vFlags = 0; //FX_FLAG_ROM_BUFFER;// | FX_FLAG_ADDRESS_CHECKING;
    mov.l       @(376,pc),r0    ; = `?FxReset@@YAXPAUFxInit_s@@@Z`
    mov.b       #0,r1
    mov.l       @(356,pc),r4    ; = `?SuperFX@@3UFxInit_s@@A`
    jsr         @r0
    mov.l       r1,@r4
;   59: }
    add.l       #16,sp          ; 16 = 0x10
    lds.l       @sp+,pr
    rts
    nop
    .endf
;   63: {
    .align      4

`?S9xResetCPU@@YAXXZ`: .entry
    mov.l       r8,@-sp
    mov.l       r9,@-sp
    mov.l       r10,@-sp
    sts.l       pr,@-sp
    add.l       #-16,sp         ; -16 = 0xfffffff0
    .prolog
;   64:     Registers.PB = 0;
    mov.b       #0,r1
    mov.l       @(368,pc),r0    ; = `?S9xGetWord@@YAGI@Z`
    mov.b       #14,r10         ; 14 = 0xe
    mov.l       @(372,pc),r8    ; = _Registers
    add.l       r8,r10
    mov.l       @(304,pc),r4    ; = 65532
    jsr         @r0
    mov.b       r1,@r8
    mov.w       r0,@(14,r8)     ; 14 = 0xe
;   66:     Registers.D.W = 0;
    mov.b       #0,r0
    mov.w       r0,@(6,r8)
;   67:     Registers.DB = 0;
    mov.b       r0,@(1,r8)
;   68:     Registers.SH = 1;
    mov.b       #1,r0
    mov.b       r0,@(9,r8)
;   69:     Registers.SL = 0xFF;
    mov.w       @(280,pc),r0    ; = 255
    mov.b       r0,@(8,r8)
;   70:     Registers.XH = 0;
    mov.b       #0,r0
    mov.b       r0,@(11,r8)     ; 11 = 0xb
;   71:     Registers.YH = 0;
    mov.b       r0,@(13,r8)     ; 13 = 0xd
;   72:     Registers.P.W = 0;
    add.l       #2,r8
    mov.w       r0,@r8
;   74:     ICPU.ShiftedPB = 0;
    mov.l       @(344,pc),r9    ; = _ICPU
    mov.l       r0,@(16,r9)     ; 16 = 0x10
;   75:     ICPU.ShiftedDB = 0;
    mov.l       r0,@(20,r9)     ; 20 = 0x14
;   76:     SetFlags (MemoryFlag | IndexFlag | IRQ | Emulation);
    mov.w       @r8,r3
    extu.w      r3,r3
    mov.w       @(252,pc),r1    ; = 308
    or.l        r1,r3
;   77:     ClearFlags (Decimal);
    mov.l       @(312,pc),r4    ; = _CPU
    extu.w      r3,r2
    mov.l       @(252,pc),r3    ; = 65527
    and.l       r3,r2
    mov.w       r2,@r8
;   79:     CPU.Flags = 0;
    mov.b       #8,r1
    mov.l       r0,@r4
;   80:     CPU.Cycles = 0;
    mov.b       #16,r2          ; 16 = 0x10
    mov.l       r0,@(32,r4)     ; 32 = 0x20
;   81:     CPU.NextEvent = Settings.HBlankStart;
    mov.l       @(284,pc),r3    ; = _Settings
    mov.l       @(8,r3),r3
    mov.l       r3,@(36,r4)     ; 36 = 0x24
;   82:     CPU.V_Counter = 0;
    mov.l       r0,@(40,r4)     ; 40 = 0x28
;   83:     CPU.BranchSkip = FALSE;
    mov.b       r0,@(4,r4)
;   84:     CPU.NMIActive = FALSE;
    mov.b       r0,@(5,r4)
;   85:     CPU.IRQActive = FALSE;
    mov.b       r0,@(6,r4)
;   86:     CPU.WaitingForInterrupt = FALSE;
    mov.b       r0,@(7,r4)
;   87:     CPU.InDMA = FALSE;
    mov.b       r0,@(8,r4)
;   88:     CPU.WhichEvent = HBLANK_START_EVENT;
    mov.b       r0,@(9,r4)
;   89:     CPU.PC = NULL;
    mov.l       r0,@(12,r4)     ; 12 = 0xc
;   90:     CPU.PCBase = NULL;
    mov.l       r0,@(16,r4)     ; 16 = 0x10
;   91:     CPU.MemSpeed = 8;
    mov.l       r1,@(44,r4)     ; 44 = 0x2c
;   92:     CPU.MemSpeedx2 = 16;
    mov.l       r2,@(48,r4)     ; 48 = 0x30
;   93:     CPU.FastROMSpeed = 8;
    mov.l       r1,@(52,r4)     ; 52 = 0x34
;   94:     CPU.PCAtOpcodeStart = NULL;
    mov.l       r0,@(20,r4)     ; 20 = 0x14
;   95:     CPU.WaitAddress = NULL;
    mov.l       r0,@(24,r4)     ; 24 = 0x18
;   96:     CPU.WaitCounter = 0;
    mov.l       r0,@(28,r4)     ; 28 = 0x1c
;   97:     S9xSetPCBase (Registers.PC);
    mov.l       @(284,pc),r0    ; = `?S9xSetPCBase@@YAXI@Z`
    mov.w       @r10,r1
    jsr         @r0
    extu.w      r1,r4
;  102:     ICPU.S9xOpcodes = S9xOpcodesM1X1;
    mov.l       @(256,pc),r2    ; = _S9xOpcodesM1X1
    mov.b       #1,r0
    mov.l       r2,@(4,r9)
;  103:     ICPU.CPUExecuting = TRUE;
    mov.b       r0,@(12,r9)     ; 12 = 0xc
;  105:     S9xUnpackStatus();
; File: C:\Data\Project\Sintendo\DC32Snes9x\Snes9x\cpuexec.h
;   96: {
;   97:     ICPU._Zero = (Registers.PL & Zero) == 0;
    mov.l       @(252,pc),r8    ; = _Registers
    mov.l       @(260,pc),r9    ; = _ICPU
    mov.b       @(2,r8),r0
    extu.b      r0,r4
    mov.l       r4,r0
    nop
    tst.l       #2,r0
    movt.l      r0
    mov.b       r0,@(9,r9)
;   98:     ICPU._Negative = (Registers.PL & Negative);
    mov.l       r4,r0
    mov.w       @(160,pc),r2    ; = 128
    and.l       r2,r0
    mov.b       r0,@(10,r9)     ; 10 = 0xa
;   99:     ICPU._Carry = (Registers.PL & Carry);
    mov.l       r4,r0
    nop
    and.l       #1,r0
    mov.b       r0,@(8,r9)
;  100:     ICPU._Overflow = (Registers.PL & Overflow) >> 6;
    mov.b       #64,r3          ; 64 = 0x40
    and.l       r3,r4
    mov.b       #-6,r1          ; -6 = 0xfffffffa
    shad.l      r1,r4
    extu.b      r4,r2
    mov.l       r2,r0
    nop
    mov.b       r0,@(11,r9)     ; 11 = 0xb
;  101: }
; File: C:\Data\Project\Sintendo\DC32Snes9x\Snes9x\cpu.cpp
;  105:     S9xUnpackStatus();
;  106: }
    add.l       #16,sp          ; 16 = 0x10
    lds.l       @sp+,pr
    mov.l       @sp+,r10
    mov.l       @sp+,r9
    rts
    mov.l       @sp+,r8
    .endf
;  114: {
    .align      4

_S9xReset: .entry
    mov.l       r8,@-sp
    mov.l       r9,@-sp
    sts.l       pr,@-sp
    add.l       #-16,sp         ; -16 = 0xfffffff0
    .prolog
    mov.l       @(160,pc),r8    ; = _Settings
;  115:     if (Settings.SuperFX)
    mov.b       #71,r0          ; 71 = 0x47
    mov.b       @(r0,r8),r1
    extu.b      r1,r1
    tst.l       r1,r1
    bt          +8              ; pc+8 = L20695
;  116: 	S9xResetSuperFX ();
;   56: {
;   57:     SuperFX.vFlags = 0; //FX_FLAG_ROM_BUFFER;// | FX_FLAG_ADDRESS_CHECKING;
    mov.l       @(136,pc),r0    ; = `?FxReset@@YAXPAUFxInit_s@@@Z`
    mov.b       #0,r3
    mov.l       @(116,pc),r4    ; = `?SuperFX@@3UFxInit_s@@A`
    jsr         @r0
    mov.l       r3,@r4
;   59: }
;  116: 	S9xResetSuperFX ();
;  121:     ZeroMemory (Memory.FillRAM, 0x8000);
L20695:
    mov.l       @(136,pc),r0    ; = _memset
    mov.b       #0,r5
    mov.l       @(120,pc),r9    ; = _Memory
    mov.l       @(100,pc),r6    ; = 32768
    jsr         @r0
    mov.l       @(20,r9),r4     ; 20 = 0x14
;  122:     memset (Memory.VRAM, 0x00, 0x10000);
    mov.b       #0,r5
    mov.l       @(120,pc),r0    ; = _memset
    mov.l       @(84,pc),r6     ; = 65536
    jsr         @r0
    mov.l       @(8,r9),r4
;  123:     memset (Memory.RAM, 0x55, 0x20000);
    mov.l       @(112,pc),r0    ; = _memset
    mov.b       #85,r5          ; 85 = 0x55
    mov.l       @(76,pc),r6     ; = 131072
    jsr         @r0
    mov.l       @r9,r4
;  125:     S9xResetCPU ();
    bsr         -266            ; -266 = 0xfffffef6, pc-266 = `?S9xResetCPU@@YAXXZ`
    nop
;  126:     S9xResetPPU ();
    mov.l       @(80,pc),r0     ; = _S9xResetPPU
    jsr         @r0
    nop
;  128:     S9xResetDMA ();
    mov.l       @(88,pc),r0     ; = _S9xResetDMA
    jsr         @r0
    nop
;  129:     S9xResetAPU ();
    mov.l       @(116,pc),r0    ; = _S9xResetAPU
    jsr         @r0
    nop
;  130:     S9xResetDSP1 ();
    mov.l       @(64,pc),r0     ; = _S9xResetDSP1
    jsr         @r0
    nop
;  131:     S9xSA1Init ();
    mov.l       @(112,pc),r0    ; = _S9xSA1Init
    jsr         @r0
    nop
;  132:     S9xInitCheatData ();
    mov.l       @(76,pc),r0     ; = `?S9xInitCheatData@@YAXXZ`
    jsr         @r0
    nop
;  134:     Settings.Paused = FALSE;
    mov.b       #0,r1
    mov.b       #17,r0          ; 17 = 0x11
    mov.b       r1,@(r0,r8)
;  135: }
    add.l       #16,sp          ; 16 = 0x10
    lds.l       @sp+,pr
    mov.l       @sp+,r9
    rts
    mov.l       @sp+,r8
L20745:
    .data.w     308             ; 308 = 0x134
    .data.w     128             ; 128 = 0x80
    .data.w     255             ; 255 = 0xff
    .data.l     65527           ; 65527 = 0xfff7
    .data.l     65532           ; 65532 = 0xfffc
    .data.l     65536           ; 65536 = 0x10000
    .data.l     131072          ; 131072 = 0x20000
    .data.l     32768           ; 32768 = 0x8000
    .data.l     `?SuperFX@@3UFxInit_s@@A`
    .data.l     _S9xResetPPU
    .data.l     _S9xResetDSP1
    .data.l     _Memory
    .data.l     `?FxReset@@YAXPAUFxInit_s@@@Z`
    .data.l     _S9xResetDMA
    .data.l     _memset
    .data.l     _Settings
    .data.l     `?S9xInitCheatData@@YAXXZ`
    .data.l     _CPU
    .data.l     `?S9xGetWord@@YAGI@Z`
    .data.l     _S9xOpcodesM1X1
    .data.l     _Registers
    .data.l     _S9xResetAPU
    .data.l     _ICPU
    .data.l     _S9xSA1Init
    .data.l     `?S9xSetPCBase@@YAXI@Z`
    .endf
    .end
